Option Compare Binary
Option Explicit On
Option Strict On

Imports System.ComponentModel
Imports System.Runtime.InteropServices
Imports System.Text

Public Class NativeLibraryDemoForm
    Private Delegate Function SHChangeIconDialogW( _
        <[In]()> ByVal hOwner As IntPtr, _
        <[In](), Out(), MarshalAs(UnmanagedType.LPWStr)> ByVal szFileName As StringBuilder, _
        <[In]()> ByVal nSize As Int32, _
        <[In](), Out()> ByRef lpIconIndex As Int32 _
    ) As Int32

    Private Delegate Function GetWindowTextW( _
        <[In]()> ByVal hWnd As IntPtr, _
        <Out(), MarshalAs(UnmanagedType.LPWStr)> ByVal lpString As StringBuilder, _
        <[In]()> ByVal nMaxCount As Int32 _
    ) As Int32

    Private Const SHChangeIconDialogWOrdinal As Int32 = 62

    Private Const ERROR_SUCCESS As Int32 = 0

    Private Const MAX_PATH As Int32 = 260

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button1.Click
        Using User32 As NativeLibrary = NativeLibrary.LoadFrom("user32.dll")
            Dim TextBuffer As New System.Text.StringBuilder(100)
            Dim Args() As Object = {Me.Handle, TextBuffer, TextBuffer.Capacity}
            Dim n As Integer = _
                CInt( _
                    User32.Invoke( _
                        "GetWindowTextW", _
                        GetType(GetWindowTextW), _
                        Args _
                    ) _
                )
            If n <> 0 Then
                MsgBox("Window text: """ & TextBuffer.ToString(0, n) & """")
            Else
                Throw New Win32Exception()
            End If
        End Using
    End Sub

    Private Sub Button2_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button2.Click
        Using Shell32 As NativeLibrary = NativeLibrary.LoadFrom("shell32.dll")
            Dim FileNameBuffer As New StringBuilder(MAX_PATH)
            FileNameBuffer.Append("shell32.dll" & ControlChars.NullChar)
            Dim Args() As Object = {Me.Handle, FileNameBuffer, FileNameBuffer.Capacity, 300}
            Dim n As Boolean = _
                CBool( _
                    Shell32.Invoke( _
                        SHChangeIconDialogWOrdinal, _
                        GetType(SHChangeIconDialogW), _
                        Args _
                    ) _
                )
            If n Then
                MsgBox("Selected icon: """ & FileNameBuffer.ToString() & "," & CInt(Args(3)) & """")
            Else
                MsgBox("Selection has been cancelled by the user.")
            End If
        End Using
    End Sub
End Class