Option Compare Binary
Option Explicit On
Option Strict On

Public Class IdentityAttribute
    Private m_Namespace As String
    Private m_Name As String
    Private m_Value As String

    Public Sub New( _
        ByVal [Namespace] As String, _
        ByVal Name As String, _
        ByVal Value As String _
    )
        Me.Namespace = [Namespace]
        Me.Name = Name
        Me.Value = Value
    End Sub

    Public Property [Namespace]() As String
        Get
            Return m_Namespace
        End Get
        Set(ByVal Value As String)
            m_Namespace = Value
        End Set
    End Property

    Public Property Name() As String
        Get
            Return m_Name
        End Get
        Set(ByVal Value As String)
            m_Name = Value
        End Set
    End Property

    Public Property Value() As String
        Get
            Return m_Value
        End Get
        Set(ByVal Value As String)
            m_Value = Value
        End Set
    End Property

    Private Function HashString( _
        ByVal Value As String _
    ) As UInt32
        Dim r As UInt32 = 0
        For Each c As Char In Value
            r = r * CUInt(65599) + Convert.ToUInt32(Char.ToUpper(c))
        Next c
        Return r
    End Function

    Public Function GetHashValue() As UInt32
        Return ((HashString(Me.Namespace) * CUInt(65599) + HashString(Me.Name)) * CUInt(65599)) + HashString(Me.Value)
    End Function
End Class